unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Menus;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    MainMenu1: TMainMenu;
    mDeutsch: TMemo;
    mEnglisch: TMemo;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    procedure Button1Click(Sender: TObject);      // Noch nur zu Überprüung
    procedure FormActivate(Sender: TObject);      // einlesen der Textdokumente + randomize
    procedure MenuItem2Click(Sender: TObject);    //einfügen
    procedure MenuItem3Click(Sender: TObject);    //sotieren
    procedure MenuItem4Click(Sender: TObject);    //beenden
    procedure MenuItem5Click(Sender: TObject);    //hilfe
  private
    procedure vertausche(x,y:integer);
    procedure sort(von,bis,tiefe: integer);
    procedure sort2(von,bis,stelle:integer);
    { private declarations }
  public
    { public declarations }
  end;

const
  laenge:integer=5; //0-5                  //Anzahl der Wörter
var
  Form1: TForm1;
    Datei : TextFile;               //
      s : string;                   //einlesen der TXT ins Array
        a:array[0..100] of string;    //Array zum bearbeiten
   german:array[0..100] of string;     //Array "german - englisch" bsp german[0] = 'Hallo - hello'
   englisch:array[0..100] of string;   //Array "englisch - german" bsp englisch[0] = 'hello - Hallo'
   i:integer;


implementation
uses Unit2;            //einbinden der Unit 2 in der Wörter hinzugefügt werden könnnen dabei wird leange um eins erhöht

{$R *.lfm}

{ TForm1 }


procedure TForm1.MenuItem5Click(Sender: TObject);  //HAUPTPROGRAM
begin
 for i:=0 to laenge do a[i]:=german[i];                 //Array german in  Array a übergeben
 sort(0,laenge,1);                                      //Sort aufrufen und von 0 bis leange nach dem 1. Buchstabe sotieren lassen

 sort2(0,laenge,1);                                      //sort2 aufrufen

 for i:=0 to laenge do german[i]:=a[i];                  //Array a in Array german zurück überschreiben
 mDeutsch.clear;
 for i:=0 to laenge do mDeutsch.Lines.Add(german[i]);   //Ausgabe

end;




procedure TForm1.FormActivate(Sender: TObject); //Einlesen der Textdokumente
begin
  AssignFile(Datei,'deutsch.txt');

   Reset(Datei);

   mDeutsch.Lines.Clear;

   i:=0;

   while not eof(Datei)

   do begin

      readln(Datei,s);

      mDeutsch.Lines.Add(s);

      german[i]:=s;

      inc(i);

      end;

   CloseFile(Datei);

   AssignFile(Datei,'englisch.txt');

   Reset(Datei);

   mEnglisch.Lines.Clear;

   i:=0;

   while not eof(Datei)

   do begin

      readln(Datei,s);

      mEnglisch.Lines.Add(s);

      englisch[i]:=s;

      inc(i);

      end;

   CloseFile(Datei);
end;

procedure TForm1.Button1Click(Sender: TObject); //Hilfsausgabe zum überprüfen was in german[x] gespeichert ist mit x:=strtoint(Edit1.text)
begin
  showmessage(german[strtoint(edit1.text)]);
end;

procedure TForm1.vertausche(x,y:integer);     //Auslagern des Vertauschen des Inhaltes von a[x] a[y]
 var hilf:string;
begin
 hilf:=a[x];
 a[x]:=a[y];
 a[y]:=hilf;
end;

procedure TForm1.sort(von,bis,tiefe: integer);    //ein auf der Theorie von QUICKSORT beruhender Sotieralghorithmus
  var pivot,vlnr,vrnl:integer;                    //Pivotelement, von links nach rechts, von rechts nach links
begin
if von<bis then                                   //abbruchsbedingung für Rekursion
   begin
   pivot:=ord(upcase(a[von][tiefe]));    //pivot=72(H) ascii code von a[1.Wort][1.Buchstabe]
   vlnr:=von+1;              //vlnr wird um eins erhöht
   vrnl:=bis;                //vrnl=6
    while (vlnr < vrnl+1) do    //solange vlnr links von vrnl ist soll er
	  begin while (ord(upcase(a[vlnr][tiefe])) <= pivot) do inc(vlnr); //solang vlnr erhöhen bis er ein wort findet das mit einem Buchstabe beginnt das nach dem Pivotelement im Alphabet kommt
                while (ord(upcase(a[vrnl][tiefe])) > pivot) do dec(vrnl);  //solang vrnl verringern bis er ein wort findet das mit einem Buchstabe beginnt das vor dem Pivotelement im Alphabet kommt
		if (vlnr < vrnl+1) then  begin             //wenn vlnr noch links von vrnl ist vertauschen
                                           Vertausche(vlnr,vrnl);
                                           inc(vlnr);
                                           dec(vrnl);
                                         end              //Wenn vlnr nicht mehr links von vrnl ist das Pivotelement an die richtige Stelle tauschen
                                 else Vertausche(vrnl,von);

          end;
    sort(von,vrnl,tiefe);               //Rekursiver Aufruf des verkleinerten Teilproblems
    sort(vrnl+1,bis,tiefe);             //Rekursiver Aufruf des verkleinerten Teilproblems
    end;
end;

procedure TForm1.sort2(von,Bis,stelle:integer);
{Weitere Sotierprocedure die überprüft ob es mehrere Wörter mit dem selben anfangsbuchstabe gibt
und diese dann nach dem 2., 3., 4.,... Buchstabe Sotiert}
var x:integer;
begin
x:=von; //nur damit beim ersten eintritt in die Schleife in Zeile 159 kein Fehler entsteht da x not seem to be initialized
if von<bis then begin               //Abruchsbedingung für Rekursion

                  for i:=von to bis do
                   begin if x<laenge+1 then x:=i+1;       //wenn er durch das erhöhen von X nicht das array verlässt x erhöhen
                                       begin
                                            if upcase(a[i][stelle])=upcase(a[x][stelle]) then     //Überprüfen ob Wort a[i] und a[i+1] den selben Anfangsbuchstabe haben
                     begin
                          x:=i;
                          while ord(upcase(a[i][stelle]))=ord(upcase(a[x+1][stelle])) do inc(x);  // Wenn ja solange x erhöhen wie a[i] und a[x+1] den selben 1./2./3./.. Buchstabe haben um zu erfahren wie viele
                                                                                                 //Wörter nacheinander den selben 1./1.& 2./1.&2.&3./.. Buchtstabe haben

                          sort(i,x,stelle+1);   //Diese Wörter nach der Stelle des letzten gemeinsamen Buchstabe sotieren
                         sort2(i,x,stelle+1);   //rekursiv aufrufen ob diese Wörter evtl auch den selben 1.& 2./1.&2.&3./.. Buchstabe haben
                     end;

                                       end;
                   end;
                end;
end;




procedure TForm1.MenuItem2Click(Sender: TObject);    //einfügen von weiteren wörter dabei wird leange um 1 erhöht
begin
  Form2.Visible:=true;
  Form1.Visible:=false;
end;



procedure TForm1.MenuItem3Click(Sender: TObject);  //Hilfe
begin
  showmessage('Hilfe!');
end;

procedure TForm1.MenuItem4Click(Sender: TObject);   //Beenden
begin
  Close;
end;

end.

